精华内容
下载资源
问答
  • try catch 语句

    千次阅读 2019-05-22 15:25:00
    try代码块抛出错误(上例用的是throw语句),JavaScript 引擎就立即把代码的执行,转到catch代码块,或者说错误被catch代码块捕获了。catch接受一个参数,表示try代码块抛出的值。 如果你不确定某些代码是否会报错,...

    try代码块抛出错误(上例用的是throw语句),JavaScript 引擎就立即把代码的执行,转到catch代码块,或者说错误被catch代码块捕获了。catch接受一个参数,表示try代码块抛出的值。
    如果你不确定某些代码是否会报错,就可以把它们放在try…catch代码块之中,便于进一步对错误进行处理。

    function isErr() {
      try {
        throw new Error('出错了……');
        console.log('此行不会执行');
      }catch(e){
        console.log(e)
      } finally {
        console.log('我一定会执行');
      }
    }
    
    isErr()
    
    

    return

    function idle(x) {
      try {
        console.log(x);
        return 'result';
      } finally {
        console.log("FINALLY");
      }
    }
    
    idle('hello')
    // hello
    // FINALLY
    // "result"
    
    展开全文
  • try catch作用

    千次阅读 多人点赞 2018-03-29 11:25:16
    try catch作用:当程序发生错误时,能够保证程序继续执行下去。用一个简单例子说明:1:无try catchpublic static void main(String[] args) { int i; i = 2/0; System.out.println(i); System.out.println...

    try catch的作用:当程序发生错误时,能够保证程序继续执行下去。

    用一个简单例子说明:

    1:无try catch

    public static void main(String[] args) {
    int i;
    i = 2/0;
    System.out.println(i);
    System.out.println(1111111111);

    }

    运行结果:不会输出111111111


    2:有try catch

    public static void main(String[] args) {
    int i;
    try {
    i = 1/0;
    System.out.println(i);
    } catch (Exception e) {
    e.printStackTrace();
    }
    System.out.println(1111111111);
    }

    运行结果:会输出1111111



    展开全文
  • try-catch语句块中变量的作用域说明try-catch语句块中变量的作用域,与其它语句块的作用域一样。 在语句块内部定义的变量,作用域在语句块内部,外部不可见。 /*语句块内部*/ try{ int a = 0; }catch...

    对try-catch语句块中变量的作用域说明

    try-catch语句块中变量的作用域,与其它语句块的作用域一样。

    • 在语句块内部定义的变量,作用域在语句块内部,外部不可见。
        /*语句块内部*/   
        try{
            int a = 0;
        }catch(Exception e){
            int b = 0;
        }finally{
            int c = 0;
        }
        /*语句块外部*/       
        //a = 5;    //非法,编译器无法识别该变量
        //b = 5;    //非法,编译器无法识别该变量
        //c = 5;    //非法,编译器无法识别该变量
    • 在语句块外部定义的变量,在语句块内部可以对变量进行修改。
        /*语句块外部*/   
        int a = 0;
        /*语句块内部*/   
        try{
            a = 5;
        }catch(Exception e){
            a = 5;
        }finally{
            a = 5;
        }
        /*语句块外部*/   
        System.out.println(a);

    运行结果为

    5
    展开全文
  • Java try catch语句详解

    2020-03-08 17:36:16
    在实际应用中,对于错误的处理是极其重要的,任何程序都很难做到百分百完美,程序中可能存在大量未知问题,所以程序开发时一定...Java 的异常处理通过 5 个关键字来实现:trycatch、throw、throws 和 finally。try...

    在实际应用中,对于错误的处理是极其重要的,任何程序都很难做到百分百完美,程序中可能存在大量未知问题,所以程序开发时一定要对各种问题进行相应的处理,而 Java 提供的异常处理机制可以帮用户更好地解决这方面的问题。Java 的异常处理机制可以让程序具有极好的容错性,让程序更加健壮。

    Java 的异常处理通过 5 个关键字来实现:try、catch、throw、throws 和 finally。try catch 语句用于捕获并处理异常,finally 语句用于在任何情况下(除特殊情况外)都必须执行的代码,throw 语句用于拋出异常,throws 语句用于声明可能会出现的异常。

    在 Java 中通常采用 try catch 语句来捕获异常并处理。语法格式如下:

    try {
        // 可能发生异常的语句
    } catch(ExceptionType e) {
        // 处理异常语句
    }
    

    在以上语法中,把可能引发异常的语句封装在 try 语句块中,用以捕获可能发生的异常。catch 后的( )里放匹配的异常类,指明 catch 语句可以处理的异常类型,发生异常时产生异常类的实例化对象。

    如果 try 语句块中发生异常,那么一个相应的异常对象就会被拋出,然后 catch 语句就会依据所拋出异常对象的类型进行捕获,并处理。处理之后,程序会跳过 try 语句块中剩余的语句,转到 catch 语句块后面的第一条语句开始执行。

    如果 try 语句块中没有异常发生,那么 try 块正常结束,后面的 catch 语句块被跳过,程序将从 catch 语句块后的第一条语句开始执行。

    注意:try…catch 与 if…else 不一样,try 后面的花括号{ }不可以省略,即使 try 块里只有一行代码,也不可省略这个花括号。与之类似的是,catch 块后的花括号{ }也不可以省略。另外,try 块里声明的变量只是代码块内的局部变量,它只在 try 块内有效,其它地方不能访问该变量。

    在上面语法的处理代码块中,可以使用以下 3 个方法输出相应的异常信息。

    	printStackTrace() 方法:指出异常的类型、性质、栈层次及出现在程序中的位置。
    	
    	getMessage() 方法:输出错误的性质。
    	
    	toString() 方法:给出异常的类型与性质。
    

    编写一个录入学生姓名、年龄和性别的程序,要求能捕捉年龄不为数字时的异常。在这里使用 try catch 语句来实现,代码如下:

    import java.util.Scanner;
    
    public class Test {
        public static void main(String[] args) {
            Scanner scanner = new Scanner(System.in);
            System.out.println("---------学生信息录入---------------");
            String name = ""; // 获取学生姓名
            int age = 0; // 获取学生年龄
            String sex = ""; // 获取学生性别
            try {
                System.out.println("请输入学生姓名:");
                name = scanner.next();
                System.out.println("请输入学生年龄:");
                age = scanner.nextInt();
                System.out.println("请输入学生性别:");
                sex = scanner.next();
            } catch (Exception e) {
                e.printStackTrace();
                System.out.println("输入有误!");
            }
            System.out.println("姓名:" + name);
            System.out.println("年龄:" + age);
        }
    }
    

    上述代码在 main() 方法中使用 try catch 语句来捕获异常,将可能发生异常的age = scanner.nextlnt();代码放在了 try 块中,在 catch 语句中指定捕获的异常类型为 Exception,并调用异常对象的 printStackTrace() 方法输出异常信息。运行结果如下所示。

    ---------学生信息录入---------------
    请输入学生姓名:
    张伟
    请输入学生年龄:
    120a
    java.util.InputMismatchException
        at java.util.Scanner.throwFor(Unknown Source)
        at java.util.Scanner.next(Unknown Source)
        at java.util.Scanner.nextInt(Unknown Source)
        at java.util.Scanner.nextInt(Unknown Source)
    输入有误!
    姓名:张伟
    年龄:0
        at text.text.main(text.java:19)
    

    多重catch语句

    如果 try 代码块中有很多语句会发生异常,而且发生的异常种类又很多。那么可以在 try 后面跟有多个 catch 代码块。多 catch 代码块语法如下:

    try {
        // 可能会发生异常的语句
    } catch(ExceptionType e) {
        // 处理异常语句
    } catch(ExceptionType e) {
        // 处理异常语句
    } catch(ExceptionType e) {
        // 处理异常语句
    ...
    }
    

    在多个 catch 代码块的情况下,当一个 catch 代码块捕获到一个异常时,其它的 catch 代码块就不再进行匹配。

    注意:当捕获的多个异常类之间存在父子关系时,捕获异常时一般先捕获子类,再捕获父类。所以子类异常必须在父类异常的前面,否则子类捕获不到。

    public class Test {
        public static void main(String[] args) {
            Date date = readDate();
            System.out.println("读取的日期 = " + date);
        }
    
        public static Date readDate() {
            FileInputStream readfile = null;
            InputStreamReader ir = null;
            BufferedReader in = null;
            try {
                readfile = new FileInputStream("readme.txt");
                ir = new InputStreamReader(readfile);
                in = new BufferedReader(ir);
                // 读取文件中的一行数据
                String str = in.readLine();
                if (str == null) {
                    return null;
                }
                DateFormat df = new SimpleDateFormat("yyyy-MM-dd");
                Date date = df.parse(str);
                return date;
            } catch (FileNotFoundException e) {
                System.out.println("处理FileNotFoundException...");
                e.printStackTrace();
            } catch (IOException e) {
                System.out.println("处理IOException...");
                e.printStackTrace();
            } catch (ParseException e) {
                System.out.println("处理ParseException...");
                e.printStackTrace();
            }
            return null;
        }
    }
    

    上述代码通过 Java I/O(输入输出)流技术从文件 readme.txt 中读取字符串,然后解析成为日期。由于 Java I/O 技术还没有介绍,大家先不要关注 I/O 技术细节,只看调用它们时方法会发生的异常就可以了。

    在 try 代码块中第 12 行代码调用 FileInputStream 构造方法可能会发生 FileNotFoundException 异常。第 16 行代码调用 BufferedReader 输入流的 readLine() 方法可能会发生 IOException 异常。FileNotFoundException 异常是 IOException 异常的子类,应该先捕获 FileNotFoundException 异常,见代码第 23 行;后捕获 IOException 异常,见代码第 26 行。

    如果将 FileNotFoundException 和 IOException 捕获顺序调换,那么捕获 FileNotFoundException 异常代码块将永远不会进入,FileNotFoundException 异常处理永远不会执行。 上述代码第 29 行 ParseException 异常与 IOException 和 FileNotFoundException 异常没有父子关系,所以捕获 ParseException 异常位置可以随意放置。

    展开全文
  • 代码如下: BEGIN TRY … … END TRY BEGIN CATCH DECLARE @ErrorMessage NVARCHAR(4000); DECLARE @ErrorSeverity INT; DECLARE @ErrorState INT; SELECT @ErrorMessage = ERROR_MESSAGE(), @ErrorSeverity = ERROR_...
  • 在 Java 中通常采用 try catch 语句来捕获异常并处理。语法格式如下: try { 逻辑代码块1; } catch(ExceptionType e) { 处理代码块1; } 在以上语法中,把可能引发异常的语句封装在 try 语句块中,用以捕获可能发生...
  • try-catch语句

    万次阅读 2019-08-17 01:15:40
    try-catch 语句,作为 JavaScript 中处理异常的一种标准方式。基本的语法如下所示: try{ // 可能会导致错误的代码 } catch(error){ // 在错误发生时怎么处理 } 如果 try 块中的任何代码发生了错误,就会立即...
  • C++:try catch语句用法

    万次阅读 多人点赞 2019-06-15 20:34:22
    C++中try catch语句用法有非常灵活,有许多种组合; 这里简单介绍以下最基本的用法; 1. 格式 try{ ... } catch{ ... } try语句块是用来判断是否有异常; catch语句块捕捉异常,并进行处理; throw是抛出异常...
  • 目录try-catch 语句作用捕获异常语句js的错误类型: try-catch 语句作用捕获异常语句 执行流程: 先执行try中的语句,如果有错误,就会将错误抛出,并且被catch捕获并去执行 ,这时候就会执行catch里的语句,...
  • Java中try catch语句

    2019-11-06 15:12:43
    一种是使用trycatch和finally关键字捕获异常 一种是通过throw和throws关键字抛出异常 这里主要详述一下捕获异常 捕获异常语法结构: try{ //可能抛出异常的语句块 }catch(SomeException1 e){//SomeException1...
  • try catch 语句中有return 的各类情况

    万次阅读 多人点赞 2018-05-13 12:17:01
    在牛客上做java题时遇到过多到关于try catch语句的问题,看了很多答案解析,在这里记录一下。首先给出一道题目:下面代码的运行结果为?public class test { public int add(int a,int b) { try { return a+b;...
  • iDEA快捷键输入try catch语句

    千次阅读 2019-05-19 10:48:34
    public class Test2 { ...选择第6个,就是try/catch语句,也可以按数字键即可 就自动创建try/catch语句   里面还有if语句、for循环、white循环等语句也是可以用快捷键来快速输入的  
  • 主要介绍了C#中Try-Catch语句真的影响程序性能吗?本文结合IL分析Try-Catch语句的性能问题,需要的朋友可以参考下
  • C# try...catch语句

    千次阅读 2020-04-15 21:49:50
    try...catch语句的基本格式如上, 在catch子句中,异常类名必须为System.Exception或从System.Exception派生的类型。 如果程序中有一些在任何情形中都必须执行的代码,那么可以将它们放在finally语句的区块中。 .....
  • 应用场景:当我们使用带资源的try语句时,使用finally也许会造成一个异常被覆盖的问题,即try语句块中会抛出某个异常,执行finally语句块中跑出了同样的异常,这样的话就会导致原有的异常会丢失,转而抛出的finally...
  • switch case 语句中使用try catch语句

    千次阅读 2019-10-31 09:33:10
    import org.apache.commons.lang.StringUtils; /** * @author zhaocunwei * @ClassName: SwitchTryCatch * @Description: switch case 语句中使用try catch语句 * @date 2019/10/31 8:46 */ ...
  • java中try catch语句执行顺序简介

    千次阅读 2018-05-31 14:53:12
    /** * @filename Test.java * @author l ... } catch (Exception e) { // ToId不为整型,说明不是给人员推送,可能是给设备推送 System.out.println("e"); } System.out.println(userid); } }
  • 主要介绍了JS异常处理的作用和实例,即try..catch语句,需要的朋友可以参考下
  • Java 异常类try-catch语句

    千次阅读 2018-12-11 01:08:11
    Java使用try-catch语句来处理异常,将可能出现的异常操作放在try部分,一旦try部分抛出异常对象,或调用某个可能抛出异常对象的方法,并且该方法抛出了异常对象,那么try部分就会立刻结束执行,转向执行相应的catch...
  • java try-catch语句

    千次阅读 2018-07-03 13:10:44
    try-catch语句 Java使用try-catch语句来处理异常,将可能出现的异常操作放在try-catch语句try部分,一旦try部分抛出异常对象,或调用某个可能抛出异常对象的方法,并且该方法抛出了异常对象,那么try部分将立刻...
  • using System; using System.Collections.Generic; using System.Linq; using System.Text;... catch (InvalidStudentException ex) { Console.WriteLine(ex.Message); } Console.ReadLine(); } } }
  • trycatch作用

    千次阅读 2018-07-16 17:18:04
    }catch(Exception e){ e.printStackTrace(); }  一个计算的话,如果除数为0,则会报错,如果没有try的话,程序直接崩溃。用try的话,则可以让程序运行下去,并且输出为什么出错! try的话,...
  • try-catch语句的用法

    2018-09-13 17:22:17
    这时就需要使用到try-catch语句。 下面介绍try-catch语句的用法。 (请注意,这是一篇编程方面的经验,不是windows操作系统的操作经验) 工具/原料 Microsoft Visual Studio 2010 方法/步骤1 ...
  •  第二:finally里面不建议放return语句,根据需要,return语句可以放在trycatch里面和函数的后。可行的做法有四:  1、return语句只在函数后出现一次。  2、return语句仅在trycatch里面都出现。  3、...
  • 该软件包包含重载Try / Catch语句的功能。 动机 添加自定义错误需要手动检查哪种类型的错误我们收到的是catch块,因为JS没有catch过载。 例如 class UserNotFoundError extends Error { // ... Some implementation...
  • java 里的 try - catch 语句的用法

    千次阅读 2018-07-19 00:29:10
    try-catch 语法 try{  放入可能发生异常的语句 }catch(ExceptionSubClass1 e){ ...  处理异常的语句 1 ... }catch(ExceptionSubClass2 e){ ...  处理异常的语句 2 ...try-catch 语句可以由几个 catch...
  • try-catch语句的嵌套

    千次阅读 2018-02-08 16:18:51
    demo1:嵌套try,内层中没有catch语句 try{ try { throw new Error("opps") } finally { console.log("finally"); } } catch(ex){ console.error("o...

空空如也

空空如也

1 2 3 4 5 ... 20
收藏数 368,945
精华内容 147,578
关键字:

trycatch语句的作用